<?php

require_once("config.inc.php");

$bilder = new MyCSV("bilder");

if (empty($_REQUEST['id']) || ! $bilder->id_exists($_REQUEST['id']))
{
    header("HTTP/1.0 404 Not Found");
    header("Location: http://" . $_SERVER['HTTP_HOST'] .
        dirname($_SERVER['PHP_SELF']) . "/");
    die();
}

if ($url_rewrite) $PHP_SELF = "";
else $PHP_SELF = $_SERVER['PHP_SELF'] . "?id=";
$id = $_REQUEST['id'];

$kommentare = new MyCSV("kommentare");

// Die Lnge des Textes darf die Kapazitt der Datendatei nicht berschreiten.
if (isset($_POST['kommentar']) && strlen($_POST['kommentar']) > 1 &&
    strlen($_POST['kommentar']) < 9900 && $_POST['kommentar'] != "Kommentar")
{
    $datensatz = array(
        'kommentar' => trim(stripslashes($_POST['kommentar'])));

    if (! $kommentare->row_exists($datensatz))
    {
        $datensatz['bilder_id'] = $id;
        $datensatz['zeit'] = date("Y-m-d H:i:s");
        $datensatz['name'] = trim(stripslashes($_POST['fullname']));
        if ($datensatz['name'] == "Name") $datensatz['name'] = "";
        $datensatz['kommentar'] = trim(stripslashes($_POST['kommentar']));

        $kommentare->insert($datensatz);
        $kommentare->write();
    }
}

$bild = $bilder->data($id);
$untertitel = strftime("$datumsformat, %H:%M Uhr", strtotime($bild['zeit']));

$first = $bilder->first();
if ($first == $id) $first = false;
$prev = $bilder->prev($id);
$next = $bilder->next($id);
$last = $bilder->last();
if ($last == $id) $last = false;

// Beginn der View-Komponente des Skriptes.

?><!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html lang="de">
  <head>
    <meta http-equiv="content-type" content="text/html; charset=ISO-8859-1">
    <title>TM::Gallery - <?=$untertitel?></title>
    <meta name="author" content="Thiemo Mttig">
    <meta name="robots" content="index,follow">
    <link rel="top" href="/" title="Zur Startseite">
    <link rel="up" href="./" title="Zur bersicht">
    <? if ($first): ?>
      <link rel="first" href="<?=$PHP_SELF?><?=$first?>" title="Zum ersten Bild">
    <? endif; ?>
    <? if ($prev): ?>
      <link rel="prev" href="<?=$PHP_SELF?><?=$prev?>" title="Zum vorigen Bild">
    <? endif; ?>
    <? if ($next): ?>
      <link rel="next" href="<?=$PHP_SELF?><?=$next?>" title="Zum nchsten Bild">
    <? endif; ?>
    <? if ($last): ?>
      <link rel="last" href="<?=$PHP_SELF?><?=$last?>" title="Zum letzten Bild">
    <? endif; ?>
    <link rel="author" href="http://maettig.com/" title="Thiemo Mttig">
    <link rel="alternate" type="application/rss+xml" title="RSS 1.0-Version der Kommentare" href="feed">
    <link rel="stylesheet" type="text/css" href="../stylesheet.css">
  </head>
  <body>

    <h1>
      TM::Gallery
      <span class="untertitel"><?=$untertitel?></span>
    </h1>

    <p class="menue">
      <a href="./<? if ($first) echo "#i$id"; ?>">&lt; Zurck zur bersicht</a>
      <br>
      <? if ($first): ?>
        <a href="<?=$PHP_SELF?><?=$first?>" title="Zum ersten Bild">&lt;&lt;</a>
      <? else: ?>
        <span class="disabled">&lt;&lt;</span>
      <? endif; ?>
      |
      <? if ($prev): ?>
        <a href="<?=$PHP_SELF?><?=$prev?>">&lt; Voriges Bild</a>
      <? else: ?>
        <span class="disabled">&lt; Voriges Bild</span>
      <? endif; ?>
      |
      <a href="#Kommentar">Kommentar hinzufgen</a>
      |
      <? if ($next): ?>
        <a href="<?=$PHP_SELF?><?=$next?>">Nchstes Bild &gt;</a>
      <? else: ?>
        <span class="disabled">Nchstes Bild &gt;</span>
      <? endif; ?>
      |
      <? if ($last): ?>
        <a href="<?=$PHP_SELF?><?=$last?>" title="Zum letzten Bild">&gt;&gt;</a>
      <? else: ?>
        <span class="disabled">&gt;&gt;</span>
      <? endif; ?>
    </p>

    <p>
      <img
        src="<?=$bild['dateiname']?>"
        alt="<?=date("j.n. G:i", strtotime($bild['zeit']))?>"
        title="Bild #<?=$bild['id']?>, aufgenommen mit <?=$bild['kamera']?> (Datei <?=substr($bild['dateiname'], -12, 8)?>)"
        width="<?=$bild['breite']?>"
        height="<?=$bild['hoehe']?>">
    </p>

    <div id="bildnummer">Bild #<?=$bild['id']?></div>

    <? if ($kommentare->count()): ?>
      <dl>
<?php
$kommentare->reset();
while ($datensatz = $kommentare->each())
{
    if ($datensatz['bilder_id'] != $id) continue;

    echo '<dt id="c' . $datensatz['id'] . '">';
    if (! empty($datensatz['name']))
    {
        echo '<span class="name">' . htmlspecialchars($datensatz['name']);
        echo '</span> schrieb am ';
    }
    echo strftime("$datumsformat, %H:%M Uhr", strtotime($datensatz['zeit']));
    echo ":</dt>\n";

    // berzhlige Zeilenumbrche auf maximal zwei (eine Leerzeile) reduzieren.
    $kommentar = preg_replace('/(\s*?\n){3,}/s', "\n\n", $datensatz['kommentar']);
    $kommentar = nl2br(htmlspecialchars($kommentar));
    // Maskierte Sonderzeichen so anzeigen, wie sie gedacht waren.
    $kommentar = preg_replace('/&amp;(?=#\d{3,4};)/', '&', $kommentar);
    // Zollzeichen durch typografische Anfhrungszeichen ersetzen.
    $kommentar = preg_replace('{(?<!\w)&quot;(.*?)&quot;(?!\w)}s',
        '&bdquo;\1&ldquo;', $kommentar);

    // Links zu anderen Bild-IDs erzeugen (experimentell!).
    $kommentar = preg_replace('/#(\d{1,2})\b/',
        '<a href="' . $PHP_SELF . '\1">\0</a>', $kommentar);

    echo "<dd>" . $kommentar . "</dd>\n";
}
?>
      </dl>
    <? endif; ?>

    <form action="<?=$PHP_SELF?><?=$id?>#Kommentar" id="Kommentar" method="post">
      <div>
        <label>Name:</label>
        <input maxlength="50" name="fullname" size="20" type="text"><br>
        <label>Kommentar:</label>
        <textarea cols="60" name="kommentar" rows="5"></textarea><br>
        <input accesskey="s" class="submit" type="submit" value="Kommentar hinzufgen">
      </div>
    </form>

  </body>
</html>