<?php

require_once("config.inc.php");
require_once("Feed.class.php");

// Encoding, link (URL), title, description.
$rss = new Feed(
    "",
    "",
    "TM::Gallery",
    "");

$bilder = new MyCSV("bilder");
$kommentare = new MyCSV("kommentare");

$kommentare->sort("zeit DESC");

while ($datensatz = $kommentare->each())
{
    // berzhlige Zeilenumbrche auf maximal zwei (eine Leerzeile) reduzieren.
    $kommentar = preg_replace('/(\s*?\n){3,}/s', "\n\n", $datensatz['kommentar']);
    $kommentar = nl2br(htmlspecialchars($kommentar));
    // Maskierte Sonderzeichen so anzeigen, wie sie gedacht waren.
    $kommentar = preg_replace('/&amp;(?=#\d{3,4};)/', '&', $kommentar);

    // Links zu anderen Bild-IDs erzeugen (experimentell!).
    $kommentar = preg_replace('/#(\d{1,2})\b/',
        '<a href="\1">\0</a>', $kommentar);

    $bild = $bilder->data($datensatz['bilder_id']);
    $kommentar = '<a href="' . ($url_rewrite ? '' : 'bild.php?id=') . $datensatz['bilder_id'] .
        '"><img src=".thumbs/' . $bild['dateiname'] . '"' .
        ' alt="' . date("j.n. G:i", strtotime($bild['zeit'])) . '"' .
        ' title="' . date("j.n., G:i", strtotime($bild['zeit'])) . ' Uhr"' .
        ' width="' . $bild['vorschaubreite'] . '" height="' . $bild['vorschauhoehe'] . '"' .
        '></a><br><br>' .
        $kommentar . '<br><br><cite>' . $datensatz['name'] . '</cite>';

    // ID (URL), title, link (URL), description, subject, date, author,
    // comments (URL), number of comments, comments RSS (URL).
    if (! $rss->addItem(
        true,
        "",
        ($url_rewrite ? '' : 'bild.php?id=') . $datensatz['bilder_id'] . "#c" . $datensatz['id'],
        $kommentar,
        "",
        $datensatz['zeit'],
        $datensatz['name'],
        true)) break;
}

// Publisher, creator, date, language.
$rss->addDCdata("", "Thiemo Mttig");
//- $rss->css = "feed.css";

if (! isset($version))
{
    $version = isset($_REQUEST['version']) ? $_REQUEST['version'] : "";
}

$rss->display($version);

?>